"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic' }"

LibraryDefinition subclass:#stx_libbasic
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libbasic class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libbasic
    This library contains basic (nonGUI) classes.
"
! !

!stx_libbasic class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'stx:goodies/sunit'    "TestResource - referenced by ProjectDefinition class>>additionalClassAttributesFor: "
        #'stx:libsvn'           "SVN::InfoCommand - referenced by ProjectDefinition class>>svnRevision "
        #'stx:libbasic3'        "ChangeNotificationParameters"
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
    )
! !

!stx_libbasic class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBBASIC_BASE
LIB_BASE=$(LIBBASIC_BASE)
'
!

localIncludes
    ^ '-I$(TOP)/librun'

    "Created: / 06-09-2006 / 18:18:06 / cg"
!

stcOptimizationOptions
    ^ '+optinline +optinline2'

    "Created: / 23-08-2006 / 11:06:17 / cg"
! !

!stx_libbasic class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        Autoload
        Object
        ProtoObject
        AbstractOperatingSystem
        AbstractSourceFileReader
        (BadRomanNumberFormatError autoload)
        Behavior
        Boolean
        CharacterEncoder
        (#'CharacterEncoderImplementations::BIG5' autoload)
        (#'CharacterEncoderImplementations::CNS11643' autoload)
        (#'CharacterEncoderImplementations::CP437' autoload)
        (#'CharacterEncoderImplementations::GB2313_1980' autoload)
        (#'CharacterEncoderImplementations::HANGUL' autoload)
        (#'CharacterEncoderImplementations::ISO10646_to_JavaText' autoload)
        (#'CharacterEncoderImplementations::ISO10646_to_SGML' autoload)
        (#'CharacterEncoderImplementations::ISO10646_to_UTF16BE' autoload)
        (#'CharacterEncoderImplementations::ISO10646_to_UTF16LE' autoload)
        (#'CharacterEncoderImplementations::ISO8859_10' autoload)
        (#'CharacterEncoderImplementations::ISO8859_11' autoload)
        (#'CharacterEncoderImplementations::ISO8859_13' autoload)
        (#'CharacterEncoderImplementations::ISO8859_14' autoload)
        (#'CharacterEncoderImplementations::ISO8859_16' autoload)
        (#'CharacterEncoderImplementations::ISO8859_3' autoload)
        (#'CharacterEncoderImplementations::ISO8859_4' autoload)
        (#'CharacterEncoderImplementations::ISO8859_6' autoload)
        (#'CharacterEncoderImplementations::ISO8859_8' autoload)
        (#'CharacterEncoderImplementations::ISO8859_9' autoload)
        (#'CharacterEncoderImplementations::JIS0201' autoload)
        (#'CharacterEncoderImplementations::JIS0208' autoload)
        (#'CharacterEncoderImplementations::JIS0208_to_EUC' autoload)
        (#'CharacterEncoderImplementations::JIS0208_to_JIS7' autoload)
        (#'CharacterEncoderImplementations::JIS0212' autoload)
        (#'CharacterEncoderImplementations::JOHAB' autoload)
        (#'CharacterEncoderImplementations::KOI7' autoload)
        (#'CharacterEncoderImplementations::KOI8_R' autoload)
        (#'CharacterEncoderImplementations::KOI8_U' autoload)
        (#'CharacterEncoderImplementations::KSC5601' autoload)
        (#'CharacterEncoderImplementations::MAC_Arabic' autoload)
        (#'CharacterEncoderImplementations::MAC_CentralEuropean' autoload)
        (#'CharacterEncoderImplementations::MAC_Croatian' autoload)
        (#'CharacterEncoderImplementations::MAC_Cyrillic' autoload)
        (#'CharacterEncoderImplementations::MAC_Dingbats' autoload)
        (#'CharacterEncoderImplementations::MAC_Farsi' autoload)
        (#'CharacterEncoderImplementations::MAC_Greek' autoload)
        (#'CharacterEncoderImplementations::MAC_Hebrew' autoload)
        (#'CharacterEncoderImplementations::MAC_Iceland' autoload)
        (#'CharacterEncoderImplementations::MAC_Japanese' autoload)
        (#'CharacterEncoderImplementations::MAC_Korean' autoload)
        (#'CharacterEncoderImplementations::MAC_Roman' autoload)
        (#'CharacterEncoderImplementations::MAC_Romanian' autoload)
        (#'CharacterEncoderImplementations::MAC_Symbol' autoload)
        (#'CharacterEncoderImplementations::MAC_Thai' autoload)
        (#'CharacterEncoderImplementations::MAC_Turkish' autoload)
        (#'CharacterEncoderImplementations::MS_Arabic' autoload)
        (#'CharacterEncoderImplementations::MS_EastEuropean' autoload)
        (#'CharacterEncoderImplementations::MS_Hebrew' autoload)
        (#'CharacterEncoderImplementations::MS_Symbol' autoload)
        (#'CharacterEncoderImplementations::MS_Turkish' autoload)
        (#'CharacterEncoderImplementations::NEXT' autoload)
        ClassBuilder
        ClassCategoryReader
        Collection
        Context
        Continuation
        Delay
        ExecutableFunction
        ExternalAddress
        (FileDirectory autoload)
        Filename
        GenericException
        Geometric
        (ImaginaryResultError autoload)
        (Infinity autoload)
        InlineObject
        InterestConverter
        (LargeFloat autoload)
        Link
        (MacFilename macos autoload)
        Magnitude
        (MappedExternalBytes autoload)
        Message
        (MetaNumber autoload)
        MiniDebugger
        MiniInspector
        (NaiveRomanNumberFormatNotification autoload)
        NameSpace
        (NotANumber autoload)
        (NumberConversionError autoload)
        (NumberFormatError autoload)
        OSErrorHolder
        ObjectMemory
        (OpenVMSFileHandle vms autoload)
        (OpenVMSFilename vms autoload)
        (OpenVMSOperatingSystem vms autoload)
        PackageId
        PluginSupport
        ProcessorScheduler
        ProgrammingLanguage
        Project
        ProjectDefinition
        (QualifiedName autoload)
        ReadEvalPrintLoop
        RecursionLock
        Registry
        (RomanNumberFormatError autoload)
        Semaphore
        SharedPool
        Signal
        Smalltalk
        (SomeNumber autoload)
        StandaloneStartup
        Stream
        (SystemNotification autoload)
        (TextCollectorStream autoload)
        (UnboundedExternalStream autoload)
        UndefinedObject
        (UnixFileDescriptorHandle unix)
        (UnixFileHandle unix)
        (UnixOperatingSystem unix)
        UserMessage
        Visitor
        (WeakValueIdentityDictionary autoload)
        (Win32Process win32)
        AbstractTime
        ApplicationDefinition
        ArithmeticValue
        AspectVisitor
        AutoDeletedFilename
        Bag
        BlockContext
        CachingRegistry
        Character
        #'CharacterEncoderImplementations::ISO10646_1'
        #'CharacterEncoderImplementations::SingleByteEncoder'
        #'CharacterEncoderImplementations::TwoByteEncoder'
        CompiledCode
        ControlInterrupt
        Date
        Exception
        ExternalFunction
        False
        HandleRegistry
        HashStream
        InlineObjectPrototype
        KeyedCollection
        LibraryDefinition
        LookupKey
        MessageSend
        NoHandlerError
        Notification
        OSHandle
        (PCFilename win32)
        PeekableStream
        Process
        QuerySignal
        Rectangle
        SequenceableCollection
        Set
        SmalltalkChunkFileSourceReader
        SmalltalkLanguage
        True
        UnixFilename
        UserNotification
        WeakInterestConverter
        ActivityNotification
        ArrayedCollection
        Association
        Block
        #'CharacterEncoderImplementations::ASCII'
        #'CharacterEncoderImplementations::ISO10646_to_UTF8'
        #'CharacterEncoderImplementations::ISO8859_1'
        #'CharacterEncoderImplementations::ISO8859_15'
        #'CharacterEncoderImplementations::ISO8859_2'
        #'CharacterEncoderImplementations::ISO8859_5'
        #'CharacterEncoderImplementations::ISO8859_7'
        #'CharacterEncoderImplementations::JIS0208_to_SJIS'
        #'CharacterEncoderImplementations::MS_Ansi'
        (#'CharacterEncoderImplementations::MS_Baltic' win32)
        (#'CharacterEncoderImplementations::MS_Cyrillic' win32)
        (#'CharacterEncoderImplementations::MS_Greek' win32)
        ClassDescription
        ControlRequest
        Dictionary
        EncodedStream
        EndOfStreamNotification
        Error
        ExternalFunctionCallback
        ExternalLibraryFunction
        HaltInterrupt
        IdentitySet
        LinkedList
        MD5Stream
        Method
        MethodDictionary
        Number
        OSFileHandle
        ObjectCoder
        OrderedCollection
        Point
        PositionableStream
        Query
        ReadOnlySequenceableCollection
        RecursiveStoreError
        SHA1Stream
        Time
        Timestamp
        UserConfirmation
        UserInformation
        UserInterrupt
        Warning
        (Win32Handle win32)
        YesToAllConfirmation
        #'stx_libbasic'
        AbortAllOperationRequest
        AbstractSourceFileWriter
        Array
        BreakPointInterrupt
        CheapBlock
        Class
        ClassBuildError
        DoubleArray
        ElementBoundsError
        FloatArray
        Fraction
        IdentityDictionary
        InlineObjectClassDescription
        Integer
        Interval
        LimitedPrecisionReal
        MeasurementValue
        Metaclass
        OsError
        ProceedError
        ProceedableError
        QueryWithoutDefault
        ReadStream
        RecursionError
        RecursiveExceptionError
        RestartProcessRequest
        SemaphoreSet
        SignalSet
        SnapshotError
        SortedCollection
        StringCollection
        TerminateProcessRequest
        UninterpretedBytes
        VMInternalError
        VarArgBlock
        WeakArray
        WeakIdentitySet
        WeakValueDictionary
        (Win32FILEHandle win32)
        WriteStream
        AbortOperationRequest
        AllocationFailure
        ArithmeticError
        AssertionFailedError
        AutoloadMetaclass
        ByteArray
        CharacterWriteStream
        ContextError
        ConversionError
        DeepCopyError
        ExceptionHandlerSet
        ExecutionError
        ExternalBytes
        FixedPoint
        Float
        GetOpt
        LargeInteger
        LongFloat
        MessageNotUnderstood
        NotFoundError
        OSSignalInterrupt
        OsIllegalOperation
        OsInaccessibleError
        OsInvalidArgumentsError
        OsNeedRetryError
        OsNoResourcesError
        OsNotification
        OsTransferFaultError
        PrivateMetaclass
        ReadWriteStream
        ShortFloat
        SignalError
        SmallInteger
        SmalltalkChunkFileSourceWriter
        StreamError
        SubclassResponsibilityError
        TimeoutError
        UnimplementedFunctionalityError
        UserPreferences
        VarArgCheapBlock
        WeakIdentityDictionary
        ArgumentError
        CannotResumeError
        CannotReturnError
        CharacterArray
        CharacterEncoderError
        DateConversionError
        DomainError
        EndOfStreamError
        ExternalStream
        ExternalStructure
        IncompleteNextCountError
        IndexNotFoundError
        InvalidCodeError
        InvalidModeError
        InvalidOperationError
        KeyNotFoundError
        MallocFailure
        NonBooleanReceiverError
        OpenError
        PositionError
        PositionOutOfBoundsError
        PrimitiveFailure
        RangeError
        ReadError
        StreamIOError
        StreamNotOpenError
        TimeConversionError
        UnorderedNumbersError
        UnprotectedExternalBytes
        WeakDependencyDictionary
        (Win32Constants win32)
        (Win32OperatingSystem win32)
        WriteError
        WrongProceedabilityError
        BadLiteralsError
        DecodingError
        EncodingError
        FileStream
        InvalidByteCodeError
        InvalidInstructionError
        InvalidReadError
        InvalidWriteError
        NoByteCodeError
        NonIntegerIndexError
        NonPositionableExternalStream
        OverflowError
        String
        SubscriptOutOfBoundsError
        TwoByteString
        UnderflowError
        WrongNumberOfArgumentsError
        ZeroDivide
        CharacterRangeError
        DirectoryStream
        InvalidEncodingError
        PipeStream
        Symbol
        Unicode16String
        SystemChangeNotifier
        ExternalLibrary
        NoModificationError
        ImmutableArray
        ImmutableByteArray
        ImmutableString
        PrototypeLookupAlgorithm
        OSProcess
        #'CharacterEncoderImplementations::EBCDIC'
        TimeoutNotification
        SameForAllNotification
        UtcTimestamp
        InvalidPatchError
        AbortAllOperationWantedQuery
        BuiltinLookup
        Lookup
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_libbasic class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Basic Classes'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:55:33 / cg"
! !

!stx_libbasic class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/stx_libbasic.st,v 1.83 2011-06-28 11:58:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libbasic/stx_libbasic.st,v 1.83 2011-06-28 11:58:19 cg Exp $'
! !
